## ros-one-magic-enum 0.9.7-31jammy.20251121.2028

=== debian/changelog ===
ros-one-magic-enum (0.9.7-31jammy.20251121.2028) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Fri, 21 Nov 2025 20:28:14 +0000

ros-one-magic-enum (0.9.7-0jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Neargye <neargye@gmail.com>  Fri, 21 Nov 2025 20:28:14 -0000

## ros-one-magic-enum 0.9.7-31noble.20251121.2030

=== debian/changelog ===
ros-one-magic-enum (0.9.7-31noble.20251121.2030) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Fri, 21 Nov 2025 20:30:27 +0000

ros-one-magic-enum (0.9.7-0noble) noble; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Neargye <neargye@gmail.com>  Fri, 21 Nov 2025 20:30:27 -0000

## ros-one-magic-enum 0.9.7-40jammy.20260208.2033

=== debian/changelog ===
ros-one-magic-enum (0.9.7-40jammy.20260208.2033) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Sun, 08 Feb 2026 20:33:59 +0000

## ros-one-magic-enum 0.9.7-40noble.20260208.2034

=== debian/changelog ===
ros-one-magic-enum (0.9.7-40noble.20260208.2034) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Sun, 08 Feb 2026 20:34:25 +0000

## ros-one-magic-enum 0.9.7-45jammy.20260228.2032

=== meson_options.txt ===
option(
    'hash',
    type : 'boolean',
    value : false,
    description : 'Do hashing at build time - longer build times, but O(1) string lookup'
)

=== test/CMakeLists.txt ===
include(CheckCXXCompilerFlag)

if(${MAGIC_ENUM_OPT_TEST_INSTALLED_VERSION})
  find_package(magic_enum REQUIRED magic_enum)
endif()

if(${MAGIC_ENUM_OPT_TEST_INSTALLED_VERSION_PKGCONFIG})
  find_package(PkgConfig)
  pkg_check_modules(magic_enum magic_enum)
  if(NOT magic_enum_FOUND)
    message(
      WARNING
        "magic_enum via pkgconfig is not found. \
Next code will try check possible places for some platforms, \
but there's no guarantee. \
If you know where the magic_enum pkgconfig files (.pc) are, \
then specify yourself variable \$\{CMAKE_PREFIX_PATH\} \
with folder like /a/path/to/magic_enum (for POSIX-like pathes), \
where in the folder exists share/pkgconfig/magic_enum.pc ."
    )
    if(UNIX AND EXISTS "/usr/local/share/pkgconfig/magic_enum.pc")
      message(DEBUG "\$\{CMAKE_PREFIX_PATH\} : ${CMAKE_PREFIX_PATH} ")
      set(CMAKE_PREFIX_PATH "/usr/local")
      message(DEBUG "\$\{CMAKE_PREFIX_PATH\} : ${CMAKE_PREFIX_PATH} ")
      pkg_check_modules(magic_enum magic_enum)
    endif()
    # code place for future workarounds for other platforms...
    if(NOT magic_enum_FOUND)
      message(FATAL_ERROR "Could not find magic_enum's config. Read a warning above.")
    endif()
  endif()
  message(DEBUG "magic_enum_FOUND : ${magic_enum_FOUND}")
  message(DEBUG "magic_enum_LIBRARIES: ${magic_enum_LIBRARIES}")
  message(DEBUG "magic_enum_LINK_LIBRARIES: ${magic_enum_LINK_LIBRARIES}")
  message(DEBUG "magic_enum_LIBRARY_DIRS: ${magic_enum_LIBRARY_DIRS}")
  message(DEBUG "magic_enum_INCLUDE_DIRS: ${magic_enum_INCLUDE_DIRS}")
  message(DEBUG "magic_enum_INCLUDE_DIR: ${magic_enum_INCLUDE_DIR}")
  message(DEBUG "magic_enum_LDFLAGS: ${magic_enum_LDFLAGS}")
  message(DEBUG "magic_enum_LDFLAGS_OTHER: ${magic_enum_LDFLAGS_OTHER}")
  message(DEBUG "magic_enum_CFLAGS: ${magic_enum_CFLAGS}")
  message(DEBUG "magic_enum_CFLAGS_OTHER: ${magic_enum_CFLAGS_OTHER}")
  message(DEBUG "magic_enum_INCLUDEDIR: ${magic_enum_INCLUDEDIR}")
  message(DEBUG "magic_enum_LIBDIR: ${magic_enum_LIBDIR}")
  message(DEBUG "magic_enum_PREFIX: ${magic_enum_PREFIX}")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  set(OPTIONS /W4 /WX)
  check_cxx_compiler_flag(/permissive HAS_PERMISSIVE_FLAG)
  if(HAS_PERMISSIVE_FLAG)
    set(OPTIONS ${OPTIONS} /permissive-)
  endif()

  check_cxx_compiler_flag(/std:c++20 HAS_CPP20_FLAG)
  check_cxx_compiler_flag(/std:c++23 HAS_CPP23_FLAG)
  check_cxx_compiler_flag(/std:c++latest HAS_CPPLATEST_FLAG)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
  set(CMAKE_VERBOSE_MAKEFILE ON)
  set(OPTIONS -Wall -Wextra -Wshadow -pedantic-errors -Werror)

  # Clang 22+ treats __COUNTER__ as C2y extension, but Catch2 v2 uses it
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "22.0")
    set(OPTIONS ${OPTIONS} -Wno-c2y-extensions)
  endif()

  check_cxx_compiler_flag(-std=c++20 HAS_CPP20_FLAG)
  check_cxx_compiler_flag(-std=c++23 HAS_CPP23_FLAG)

  # Clang 17 with libstdc++ 14 has a known bug in C++23 mode (tuple/get incompatibility)
  # Skip C++23 tests for Clang 17.x to avoid compilation errors
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "17.0" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "18.0")
    set(HAS_CPP23_FLAG FALSE)
    message(STATUS "Skipping C++23 tests for Clang 17 due to libstdc++ 14 incompatibility")
  endif()
endif()

function(make_test src target std)
  add_executable(${target} ${src})
  target_compile_options(${target} PRIVATE ${OPTIONS})
  target_include_directories(${target} PRIVATE 3rdparty/Catch2/include)
  if(${MAGIC_ENUM_OPT_TEST_INSTALLED_VERSION_PKGCONFIG})
    target_include_directories(${target} PRIVATE ${magic_enum_INCLUDE_DIRS})
  else()
    target_link_libraries(${target} PRIVATE magic_enum::magic_enum)
  endif()
  set_target_properties(${target} PROPERTIES CXX_EXTENSIONS OFF)
  if(std)
    if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
      target_compile_options(${target} PRIVATE /std:${std})
    else()
      target_compile_options(${target} PRIVATE -std=${std})
    endif()
  endif()
  add_test(NAME ${target} COMMAND ${target})
endfunction()

make_test(test.cpp test-cpp17 c++17)
make_test(test_flags.cpp test_flags-cpp17 c++17)
make_test(test_aliases.cpp test_aliases-cpp17 c++17)
make_test(test_containers.cpp test_containers-cpp17 c++17)
make_test(test_wchar_t.cpp test_wchar_t-cpp17 c++17)

if(MAGIC_ENUM_OPT_ENABLE_NONASCII)
  make_test(test_nonascii.cpp test_nonascii-cpp17 c++17)
endif()

if(HAS_CPP20_FLAG)
  make_test(test.cpp test-cpp20 c++20)
  make_test(test_flags.cpp test_flags-cpp20 c++20)
  make_test(test_aliases.cpp test_aliases-cpp20 c++20)
  make_test(test_containers.cpp test_containers-cpp20 c++20)
  make_test(test_wchar_t.cpp test_wchar_t-cpp20 c++20)
  if(MAGIC_ENUM_OPT_ENABLE_NONASCII)
    make_test(test_nonascii.cpp test_nonascii-cpp20 c++20)
  endif()
endif()

if(HAS_CPP23_FLAG)
  make_test(test.cpp test-cpp23 c++23)
  make_test(test_flags.cpp test_flags-cpp23 c++23)
  make_test(test_aliases.cpp test_aliases-cpp23 c++23)
  make_test(test_containers.cpp test_containers-cpp23 c++23)
  make_test(test_wchar_t.cpp test_wchar_t-cpp23 c++23)
  if(MAGIC_ENUM_OPT_ENABLE_NONASCII)
    make_test(test_nonascii.cpp test_nonascii-cpp23 c++23)
  endif()
endif()

if(HAS_CPPLATEST_FLAG)
  make_test(test.cpp test-cpplatest c++latest)
  make_test(test_flags.cpp test_flags-cpplatest c++latest)
  make_test(test_aliases.cpp test_aliases-cpplatest c++latest)
  make_test(test_containers.cpp test_containers-cpplatest c++latest)
  make_test(test_wchar_t.cpp test_wchar_t-cpplatest c++latest)
  if(MAGIC_ENUM_OPT_ENABLE_NONASCII)
    make_test(test_nonascii.cpp test_nonascii-cpplatest c++latest)
  endif()
endif()

=== debian/changelog ===
ros-one-magic-enum (0.9.7-45jammy.20260228.2032) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Sat, 28 Feb 2026 20:32:27 +0000

=== debian/control ===
Source: ros-one-magic-enum
Section: misc
Priority: optional
Maintainer: Neargye <neargye@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: 
Standards-Version: 3.9.2

Package: ros-one-magic-enum
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: Static reflection for enums (to string, from string, iteration) for modern C++, work with any enum type without any macro or boilerplate code

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-magic-enum//opt/ros/one/lib/:$(CURDIR)/debian/ros-one-magic-enum//opt/ros/one/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-magic-enum 0.9.7-45noble.20260228.2033

=== debian/changelog ===
ros-one-magic-enum (0.9.7-45noble.20260228.2033) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Sat, 28 Feb 2026 20:33:09 +0000
